/*
 * Copyright (C) 2011 Filippo Forchino <filippo.forchino@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONNECTIONTHREAD_H_
#define CONNECTIONTHREAD_H_

#include <FApp.h>
#include <FBase.h>
#include <FSystem.h>
#include <FUi.h>

#include "SmartCam.h"
#include "settings/UserSettings.h"

class ConnectionThread :
 public CommHandlerObserver,
 public Osp::Base::Runtime::Thread
 {
	 friend class SmartCam;
public:
	enum { OPERATION_CONNECT, OPERATION_DISCONNECT };
	ConnectionThread(class SmartCam *p);
    virtual ~ConnectionThread();
    bool Init(void);
	// From CommHandlerObserver:
	void OnConnected();
	void OnConnectError(result errCode, const String& errMsg);
	void OnDisconnected();
	bool IsConnected();
	void OnUserEventReceivedN(RequestId requestId, Osp::Base::Collection::IList* pArgs);

protected:
    int operation;
    class SmartCam *parent;
    class CommHandler *pCommHandler;
};

#endif // CONNECTIONTHREAD_H_
