/*
 * Copyright (C) 2011 Filippo Forchino <filippo.forchino@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CAMERAFORM_H_
#define _CAMERAFORM_H_

#include <FBase.h>
#include <FUi.h>

class CameraHandler;
class SmartCam;

class CameraForm :
	public Osp::Ui::Controls::Form,
	public Osp::Ui::IActionEventListener
{

// Construction
public:
	CameraForm();
	virtual ~CameraForm();
	bool Initialize();
	Osp::Graphics::BufferInfo* GetBufferInfo();
	result EnableCameraPreview(Osp::Ui::Orientation orientation);
	void DisableCameraPreview();
// Implementation
protected:
	static const int ID_OPTIONMENU_DISCONNECT = 102;

public:
	virtual result OnInitializing();
	virtual result OnTerminating();
	virtual void OnActionPerformed(const Osp::Ui::Control& source, int actionId);

private:
	result CreateOverlayPanel();

	// Data:
	SmartCam* pSmartCamApp;
	Osp::Ui::Controls::OverlayPanel* pOverlayPanel;
	Osp::Graphics::BufferInfo* pBufferInfo;
	bool showCamPreview;
	bool isTerminated;
};

#endif	//_CAMERAFORM_H_
