/*
 * Copyright (C) 2011 Filippo Forchino <filippo.forchino@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MAINMENUFORM_H_
#define _MAINMENUFORM_H_

#include <FBase.h>
#include <FUi.h>

class CameraHandler;
class SmartCam;

class MainMenuForm :
	public Osp::Ui::Controls::Form,
	public Osp::Ui::IActionEventListener,
	public Osp::Ui::IAnimationEventListener,
	public Osp::Ui::IOrientationEventListener
{

// Construction
public:
	MainMenuForm();
	virtual ~MainMenuForm();
	bool Initialize();
// Implementation
protected:
	static const int ID_OPTIONMENU_CONNECT = 101;
	static const int ID_OPTIONMENU_DISCONNECT = 102;
	static const int ID_OPTIONMENU_SETTINGS = 103;
	static const int ID_OPTIONMENU_HELP = 104;
	static const int ID_OPTIONMENU_ABOUT = 105;
	static const int ID_OPTIONMENU_EXIT = 106;
	static const int ID_LEFT_SOFTKEY = 900;
	static const int ID_RIGHT_SOFTKEY = 901;

public:
	virtual result OnInitializing();
	virtual result OnTerminating();
	virtual void OnActionPerformed(const Osp::Ui::Control& source, int actionId);
	// From Osp::Ui::IAnimationEventListener:
	void OnAnimationStopped(const Osp::Ui::Control& source);
	void ShowWaitDlg();
	void HideWaitDlg();
	void OnOrientationChanged (const Osp::Ui::Control &source, Osp::Ui::OrientationStatus orientationStatus);

private:
	void CreateWaitDlg();
	void CreateWaitAnimation();

	// Data:
	SmartCam* pSmartCamApp;
	bool showCamPreview;
	bool isTerminated;
	// Wait dlg
	Osp::Ui::Controls::Popup* pWaitDlg;
	Osp::Ui::Controls::Animation* pWaitAnimation;
	Osp::Base::Collection::ArrayList* pAnimationFrameList;
};

#endif	// _MAINMENUFORM_H_
