/*
 * Copyright (C) 2011 Filippo Forchino <filippo.forchino@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "gui/AboutForm.h"
#include "SmartCam.h"

using namespace Osp::Base;
using namespace Osp::Ui;
using namespace Osp::Ui::Controls;


AboutForm::AboutForm(void)
{
}

AboutForm::~AboutForm(void)
{
	AppLog("~AboutForm START");
	AppLog("~AboutForm END");
}

bool
AboutForm::Initialize()
{
	Form::Construct(L"IDF_ABOUTFORM");

	SetSoftkeyActionId(SOFTKEY_1, ID_RIGHT_SOFTKEY);
	AddSoftkeyActionListener(SOFTKEY_1, *this);
	AddOrientationEventListener(*this);

	return true;
}

result
AboutForm::OnInitializing(void)
{
	result r = E_SUCCESS;

	// TODO: Add your initialization code here

	return r;
}

result
AboutForm::OnTerminating(void)
{
	result r = E_SUCCESS;

	// TODO: Add your termination code here

	return r;
}


void
AboutForm::OnActionPerformed(const Control& source, int actionId)
{
	SmartCam* smartCamApp = static_cast<SmartCam*>(Osp::App::Application::GetInstance());

	switch(actionId)
	{
	// Soft keys:
	case ID_RIGHT_SOFTKEY:
		{
			smartCamApp->DisplayMainMenuForm();
		}
		break;

	default:
		break;
	}
}

void
AboutForm::OnOrientationChanged(const Osp::Ui::Control &source, Osp::Ui::OrientationStatus orientationStatus)
{
	SmartCam* smartCamApp = static_cast<SmartCam*>(Osp::App::Application::GetInstance());

	AppLog("Orientation changed!");
	if (!IsVisible()) return;
 	Label *pBg = static_cast<Label *>(GetControl(L"IDC_LABEL5"));

	if (orientationStatus == ORIENTATION_STATUS_PORTRAIT ||
			orientationStatus == ORIENTATION_STATUS_PORTRAIT_REVERSE)
	{
		pBg->SetBackgroundBitmap(*(smartCamApp->bmpBGP));
		pBg->SetBounds(0,0,480,762);
	}
	else if (orientationStatus == ORIENTATION_STATUS_LANDSCAPE ||
			orientationStatus == ORIENTATION_STATUS_LANDSCAPE_REVERSE)
	{
		pBg->SetBackgroundBitmap(*(smartCamApp->bmpBGL));
		pBg->SetBounds(0,0,800,442);
	}
	Draw();
	Show();
}


